process.env.TELEGRAM_TOKEN = '1234'

const Hubot = require('hubot/es2015')
// const TelegramBot = require('node-telegram-bot-api')
const TelegramBot = jest.genMockFromModule('node-telegram-bot-api')
jest.mock('node-telegram-bot-api')

TelegramBot.getMe = jest.fn(() =>
  Promise.resolve({
    id: 1,
    first_name: 'TestBot',
    username: 'TestBot'
  })
)

// const getUpdates = jest.fn(() => ({
//   message: {
//     update_id: 123456789,
//     message: {
//       message_id: 1,
//       from: {
//         id: 1234567890,
//         first_name: 'John',
//         last_name: 'Doe',
//         username: 'JohnDoe'
//       },
//       chat: {
//         id: 1234567890,
//         first_name: 'John',
//         last_name: 'Doe',
//         username: 'JohnDoe',
//         type: 'private'
//       },
//       date: 1459957719,
//       text: '/start start'
//     }
//   },
//   metadata: { type: 'text' }
// }))

// jest.mock('node-telegram-bot-api', () => {
//   return jest.fn().mockImplementation(() => ({
//     startPolling: jest.fn(),
//     getMe: jest.fn(() =>
//       Promise.resolve({
//         id: 1,
//         first_name: 'TestBot',
//         username: 'TestBot'
//       })
//     ),
//     getUpdates
//   }))
// })

describe('Robot', () => {
  var hubot

  beforeEach(() => {
    jest.clearAllMocks()
    Hubot.Robot.prototype.loadAdapter = function () {
      this.adapter = require('../src/telegram').use(this)
    }

    hubot = new Hubot.Robot('../src', 'telegram', true, 'TestBot')
    hubot.alias = 'TestAliasBot'
    hubot.run()
  })

  afterEach(() => {
    hubot.server.close()
    hubot.shutdown()
  })

  it('should not fail', () => {
    expect(TelegramBot.getUpdates).toHaveBeenCalled()
  })
})
